package swingtables.logic;

import java.util.ArrayList;
import java.util.List;

public class MoviesDatasource {

    private MoviesDatasource() {
        loadData();
    }
    private static MoviesDatasource moviesDatasourceInstance = null;

    public static MoviesDatasource getInstance() {
        if (moviesDatasourceInstance == null) {
            moviesDatasourceInstance = new MoviesDatasource();
        }
        return moviesDatasourceInstance;
    }
    private List<Movie> movies;
    private List<Genre> genres;

    public final void loadData() {
        movies = new ArrayList<>();
        genres = new ArrayList<>();
        Genre genre;
        Movie movie;

        genre = new Genre();
        genre.setId(0);
        genre.setGenreName("Comedy");
        genres.add(genre);

        genre = new Genre();
        genre.setId(1);
        genre.setGenreName("Drama");
        genres.add(genre);

        genre = new Genre();
        genre.setId(2);
        genre.setGenreName("Biography");
        genres.add(genre);

        genre = new Genre();
        genre.setId(3);
        genre.setGenreName("Action");
        genres.add(genre);

        genre = new Genre();
        genre.setId(4);
        genre.setGenreName("Adventure");
        genres.add(genre);

        movie = new Movie();
        movie.setId(10);
        movie.setTitle("The Dark Knight");
        movie.setColor(true);
        movie.setYearOfProduction(2008);
        movie.setGenre(genres.get(3));
        movies.add(movie);

        movie = new Movie();
        movie.setId(11);
        movie.setTitle("Il buono, il brutto, il cattivo");
        movie.setColor(true);
        movie.setYearOfProduction(1966);
        movie.setGenre(genres.get(4));
        movies.add(movie);

        movie = new Movie();
        movie.setId(12);
        movie.setTitle("Intouchables");
        movie.setColor(true);
        movie.setYearOfProduction(2011);
        movie.setGenre(genres.get(0));
        movies.add(movie);

        movie = new Movie();
        movie.setId(13);
        movie.setTitle("Rush");
        movie.setColor(true);
        movie.setYearOfProduction(2013);
        movie.setGenre(genres.get(2));
        movies.add(movie);
    }

    public List<Movie> getMovies() {
        return movies;
    }

    public List<Genre> getGenres() {
        return genres;
    }

    public int addMovie() {
        movies.add(new Movie());
        return movies.size() - 1;
    }

    public void deleteMovie(int index) {
        movies.remove(index);
    }
}
